{.Title 'IBM PC On_Line Helper With Menu Selection'}
{$C-}
{$V-}
{$R-}
{$K-}
{******************************************************************************
*   IBM PERSONAL COMPUTER INVOKABLE HELP V6.1 - For public domain use only    *
*                                                                             *
*       Main routine for memory resident HELP. Requires HELP.INC.             *
*       Compile with max/min dynamic memory = $0200 paragraphs                *
*                                                                             *
*                              David N. Ikle'                                 *
*                              1671 Newport St.                               *
*                              Denver, CO 80220                               *
*                              303-333-9322                                   *
*                                                                             *
*       Re-worked for menu selecting and code optimization.                   *
*                                                                             *
*                              C. H. Thomann                                  *
*                              635 W 39th Terr.                               *
*                              K.C., Mo  64111                                *
*                              816-753-0967                                   *
******************************************************************************}
Program Helper;
Type
  menu_array        = array[1..10] of String[44];

Const
  Our_Scan          : Byte = 94;
  Our_Char          : Byte = 0;
  color_of_frame    : Byte = yellow;
  color_of_header   : Byte = brown;
  color_of_prompt   : Byte = green;
  color_of_text     : Byte = green;
  color_of_keyline  : Byte = cyan;
  color_of_response : Byte = lightgreen;
  top_line          : Byte = 06;
  left_column       : Byte = 18;

  menu : menu_array =
    ('                                            ',
     '   IBM PERSONAL COMPUTER ON-LINE HELP V6.1  ',
     '    For public domain use only; 05/15/86    ',
     '                                            ',
     '                                            ',
     '                                            ',
     ' Keywords are names of commands or features ',
     '     Enter ? or HELPER for instructions     ',
     '      Press Enter While Blank to quit       ',
     '                                            ');

  Null = #0;
  CR   = #13;
  Esc  = #27;
  FF   = #12;

  current_page    : Byte = 00;
  write_attribute : Byte = 07;

  menu_page   = 0;
  text_page   = 3;

  max_levels  = 15;    {max number of levels of menu nesting}
  max_rows    = 23;    {max number of text lines in the display}
  max_lines   = 184;   {max number of lines in the text files}

  message_1 : String[51] =
' return; Esc exit; ,,PgUp,PgDn,Home,End scroll';
  message_2 : String[59] =
'Function Key Selects Topic,  return; Esc exits';
{.Pa}
type
  Work_String   = String[80];
  text_array    = array[1..184] of String[80];
  stack_type    = array[1..25] of Array [1..2] of String [79];
  menu_ch_type  = array[1..12] of Array [1..46] of Char;
  menu_byt_type = array[1..12] of Array [1..46] of Byte;
  text_file     = text[$800];

Var
  screen_stack   : ^stack_type;
  menu_ch_stack  : ^menu_ch_type;
  menu_byt_stack : ^menu_byt_type;

  infile         : text_file;

  row,
  line,
  entry_line,
  menu_line,
  page,
  column,
  current_location,
  line_count,
  start_last_page,
  x,
  y,
  line_length,
  byt             : Byte;
  ch              : Char;
  text_buffer     : text_array;
  help_name       : String[36];
  work_s          : String[80];
  invoke_from_parm,
  valid_name,
  in_menu         : Boolean;

  menu_level      : Byte;
  last_menu_name  : Array [1..max_levels] of String[40];

  mono_screen_page3  : Char absolute $B300:$0000;
  color_screen_page3 : Char absolute $BB00:$0000;
{.Pa}
{$I \Turbo\Incs\RegRec.Var    }
{$I \Turbo\Incs\Cursors.Dos   }
{$I \Turbo\Incs\ReadScrn.Dos  }
{$I \Turbo\Incs\GotoXY.Dos    }
{$I \Turbo\Incs\WhrCrs.Dos    }
{$I \Turbo\Incs\ClrScr.Dos    }
{$I \Turbo\Incs\Max.Fnc       }
{$I \Turbo\Incs\Min.Fnc       }
{$I \Turbo\Incs\UpWord.Fnc    }
{$I \Turbo\Incs\Asci2Int.Fnc  }
{$I \Turbo\Incs\NonPos.Fnc    }
{$I \Turbo\Incs\Remove.Fnc    }
{$I \Turbo\Incs\Strng.Fnc     }
{$I \Turbo\Incs\NonZero.Fnc   }
{$I \Turbo\Incs\Stroke.Fnc    }
{$I \Turbo\Incs\Beep.Prc      }
{$I \Turbo\Incs\Write.Prc     }
{$I \Turbo\Incs\TextColr.Prc  }
{$I \Turbo\Incs\PosWrite.Prc  }
{$I \Turbo\Incs\NewPage.Prc   }
{$I \Turbo\Incs\ScnScrll.Prc  }
{.Nest=00}
{.Pa}
Procedure Save_Menu_Area;
Begin
No_Cursor;
For y := (top_line - 1) to (top_line + 10) do
   For x := (left_column - 1) to (left_column + 44) do
      Read_Screen (current_page, y, x,
                   menu_byt_stack^[y, x], menu_ch_stack^[y, x]);
End;

Procedure Restore_Menu_Area;
Begin
For y := (top_line - 1) to (top_line + 10) do
   For x := (left_column - 1) to (left_column + 44) do
      Pos_Write (menu_page, y, x, menu_byt_stack^[y, x], menu_ch_stack^[y, x]);
End;

Procedure Save_Text_Area;
Begin
Intr ($11, Register_Record);
If (Register_Record.AX and 48) = 48 then
   Move (mono_screen_page3, screen_stack^, 4000)
Else
   Move (color_screen_page3, screen_stack^, 4000);
End;

Procedure Restore_Text_Area;
Begin
Intr ($11, Register_Record);
If (Register_Record.AX and 48) = 48 then
   Move (screen_stack^, mono_screen_page3, 4000)
Else
   Move (screen_stack^, color_screen_page3, 4000);
End;

Procedure Draw_Box (menu_page, row1, column1, row2, column2 : Byte);
Begin
Pos_Write (menu_page, row1, column1, color_of_frame, '');
for column := column1+1 to column2-1 do
   Pos_Write (menu_page, row1, column, color_of_frame,'');
Pos_Write (menu_page, row1, column2, color_of_frame, '');
for row := row1+1 to row2-1 do
   Begin
   Pos_Write (menu_page, row, column1, color_of_frame, '');
   Pos_Write (menu_page, row, column2, color_of_frame, '');
   End;
Pos_Write (menu_page, row2, column1, color_of_frame, '');
for column := column1+1 to column2-1 do
   Pos_Write (menu_page, row2, column, color_of_frame, '');
Pos_Write (menu_page, row2, column2, color_of_frame, '');
End;

Procedure Display_Prompt;
Begin
Pos_Write (menu_page, entry_line, left_column + 8,
           color_of_prompt, 'Enter keyword');
Pos_Write (menu_page, entry_line, left_column + 24, color_of_frame, '==>');
End;

Procedure Display_Prompt_Window;
Begin
Draw_Box(menu_page, top_line-1, left_column-1, top_line+10, left_column+44);
For row := 1 to 7 do
   Pos_Write (menu_page, row+top_line-1, left_column,
              color_of_header, menu[row]);
For row := 8 to 11 do
   Pos_Write (menu_page, row+top_line-1, left_column,
              color_of_text, menu[row]);
entry_line := top_line + 4;
End;

Procedure Write_String;
Begin
Pos_Write (menu_page, entry_line, column + 1, color_of_response, help_name);
gotoxy (column + current_location, entry_line);
End;
{.Pa}
Procedure Get_Name;
var
  inserting : Boolean;

Procedure Write_Character;
Begin
If current_location <= 8 then
   Begin
   If inserting then
      Begin
      Insert (ch, help_name, current_location);
      Delete (help_name, 8, 1);
      End
   Else
      help_name[current_location] := ch;
   current_location := current_location + 1;
   Write_String;
   End
Else
   Beep;
End;

Procedure Escape;
Begin
current_location := 1;
FillChar (help_name[1], 8, ' ');
Write_String;
End;

Procedure Home;
Begin
current_location := 1;
Write_String;
End;

Procedure Lt_Arrow;
Begin
If current_location > 1 then
   Begin
   current_location := current_location - 1;
   Write_String;
   End
Else
   Beep;
End;

Procedure Rt_Arrow;
Begin
If current_location < 8 then
   Begin
   current_location := current_location + 1;
   Write_String;
   End
Else
   Beep;
End;

Procedure End_Key;
Begin
current_location := Max (1, Non_Zero (Pos (' ', help_name), 9) - 1);
Write_String;
End;

Procedure Insert_Char;
Begin
If inserting then
   Begin
   inserting := False;
   Normal_Cursor;
   End
Else
   Begin
   inserting := True;
   Insert_Cursor;
   End;
End;
{.Pa}
Procedure Delete_Char;
Begin
Delete (help_name, current_location, 1);
help_name := help_name + ' ';
write_String;
End;

Procedure Back_Space;
Begin
If current_location > 1 then
   Begin
   delete(help_name, current_location-1, 1);
   current_location := current_location - 1;
   help_name := help_name + ' ';
   write_String;
   End
Else
   Beep;
End;

Begin
column := left_column + 27;
current_location := 1;
inserting := False;
help_name := Copy (help_name + '        ', 1, 8);
Write_String;
Repeat
   Begin
   If Get_Stroke (ch) = extended then
      Case Ord (ch) of
         27 : Escape;
         71 : Home;
         75 : Lt_Arrow;
         77 : Rt_Arrow;
         79 : End_Key;
         82 : Insert_Char;
         83 : Delete_Char;
         Else Beep;
         End
   Else
      Begin
      Case Ord (ch) of
          8 : Back_Space;
         13 : ;
         42 : Begin
              If current_location > 1 then
                 Beep
              Else
                 Begin
                 help_name := '###';
                 ch := CR;
                 End;
              End;
         63 : Begin
              help_name := 'HELP';
              Pos_Write (menu_page, entry_line, column + 1,
                         color_of_response, '?');
              ch := CR;
              End;
     48..57,                        {numeric digits}
     65..90,                        {upper case letters}
    97..122,                        {lower case letters}
  33,35..41,
   45,64,95,
 96,123,125 : Write_Character;      {special Characters}
         Else Beep;
         End;
      If current_location > 8 then
         ch := CR;
      End;
   End
Until ch = CR;
help_name := Remove (help_name, ' ');
End;
{.Pa}
Procedure Find_Menu_Line;
Begin
menu_level := Min (menu_level + 1, max_levels);
x := (page - 1) * 23;
For line := 1 to max_rows do
   Begin
   work_s := UpWord (Copy (text_buffer[x + line], 1, 5));
   If work_s = 'MENU:' then
      menu_line := line + 1;
   End;
End;

Procedure Load_Help_File;
Begin
line_count := 0;
line       := 0;
in_menu    := False;
Repeat
   Begin
   line_count := line_count + 1;
   line := line + 1;
   If line > max_rows then
      line := 1;
   FillChar (text_buffer[line_count], 81, Null);
   Readln (infile, text_buffer[line_count]);
   If text_buffer[line_count][1] = FF then
      Begin
      x := line_count;
      line_count := line_count + max_rows - line;
      While x <= line_count do
         Begin
         FillChar (text_buffer[x], 81, Null);
         x := x + 1;
         End;
      line := 0;
      End
   Else
      Begin
      work_s := UpWord (Copy (text_buffer[line_count], 1, 5));
      If work_s = 'MENU:' then
         in_menu := True;
      End;
   End
Until EOF(infile)
   Or (line_count >= max_lines);
If in_menu then
   Begin
   page    := 1;
   Find_Menu_Line;
   last_menu_name[menu_level] := help_name;
   End;
Close (infile);
If line_count <= max_rows then
   start_last_page := 1
Else
   start_last_page := line_count - max_rows + 1;
End;
{.Pa}
Procedure Open_Help_File;
Begin
If Pos ('.', help_name) = 0 then
   help_name := help_name + '.###';
Assign (infile, help_name);
{$I-} Reset (infile) {$I+};
If IOResult <> 0 then
   Beep
Else
   Begin
   valid_name := True;
   Load_Help_File;
   End;
End;

Procedure Get_Help_Name;
Begin
Display_Prompt;
Normal_Cursor;
valid_name := false;
If not invoke_from_parm then
   help_name := '';
repeat
   Begin
   x := Pos ('.', help_name);
   If x > 0 then
      Delete (help_name, x, Length (help_name));
   If not invoke_from_parm then
      Get_Name;
   If (help_name = '') then
      valid_name := true
   Else
      Open_Help_File;
   invoke_from_parm := False;
   End
until valid_name;
No_Cursor;
End;
{.Pa}
Procedure Display_Help;
var
  first_line       : Byte;
  display_required : Boolean;

Procedure Display_Line;
Begin
line := first_line + row - 1;
work_s := text_buffer[line];
If in_menu then
   Begin
   x := Pos ('@', work_s);
   If x > 0 then
      Delete (work_s, x, Length(work_s));
   End;
Writeln (work_s);
End;

Procedure Display_Page;
Begin
If in_menu then
   Begin
   first_line := ((page - 1) * max_rows) + 1;
   For row := 1 to (menu_line - 1) do
      Pos_Write (text_page, row, 1,
                 color_of_header, text_buffer[first_line + row - 1]);
   Writeln;
   End
Else
   row := 0;
TextColor (color_of_text);
Repeat
   Begin
   row := row + 1;
   Display_Line;
   End
Until (row >= max_rows) Or (line >= line_count);
If in_menu then
   Begin
   work_s := message_2 + '; Menu level #' + Strng (menu_level, 2) + '.';
   Pos_Write (text_page, 25, 1, color_of_keyline, work_s);
   End
Else
   Begin
   work_s := message_1;
   If menu_level > 0 then
      work_s := work_s + '; F# back #menus';
   work_s := work_s + ' ';
   Pos_Write (text_page, 25, 1, color_of_keyline, work_s);
   TextColor (color_of_text);
   If line >= line_count then
      Write ('<EndOfFile>')
   Else
      Write ('<Continued>');
   End;
End;

Procedure Beeper;
Begin
Beep;
display_required := False;
End;
{.Pa}
Procedure Scroll (way : Integer);
Begin
Scroll_Screen_Area (1, 1, 80, max_rows, way);
first_line := first_line + way;
If way > 0 then
   Begin
   GotoXY (1, max_rows);
   row := max_rows;
   End
Else
   Begin
   GotoXY (1, 1);
   row := 1;
   End;
Display_Line;
display_required := False;
End;

Procedure Text_Help_File;
Begin
If Get_Stroke (ch) = extended then
   Begin
   Case Ord (ch) of
      27     : help_name := '';                       {escape}
      59..68 : If menu_level = 0 then                 {Function key}
                  Beeper
               Else
                  Begin
                  menu_level := Max (1, menu_level-(Ord(ch)-59));
                  While last_menu_name[menu_level][1] = '#' do
                     menu_level := menu_level - 1;
                  help_name  := last_menu_name [menu_level];
                  menu_level := menu_level - 1;
                  Open_Help_File;
                  End;
      71     : If first_line <= 1 then                {home key}
                  Beeper
               Else
                  first_line := 1;
      72     : If first_line <= 1 then                {up arrow}
                  Beeper
               Else
                  Scroll (-1);
      80     : If first_line >= start_last_page then  {down arrow}
                  Beeper
               Else
                  Scroll (+1);
      73     : If first_line <= 1 then                {page up}
                  Beeper
               Else
                  first_line := max(1,first_line-max_rows);
      81     : If first_line >= start_last_page then  {page down}
                  Beeper
               Else
                  first_line := min(start_last_page,first_line+max_rows);
      79     : If first_line >= start_last_page then  {End key}
                  Beeper
               Else
                  first_line := start_last_page;
          Else Beeper;
          End;
          If display_required then
             ClrScr;
      End
Else
   If ch <> Cr then
      Beeper;
End;
{.Pa}
Procedure Menu_Help_File;
Begin
If Get_Stroke (ch) = extended then
   Begin
   If ch = Esc then
      Begin
      If menu_level = 1 then
         help_name := ''
      Else
         Begin
         menu_level := menu_level - 1;
         help_name  := last_menu_name [menu_level];
         If help_name[1] = '#' then
            Begin
            page := Ascii_to_Integer (help_name[2], 2);
            menu_line := Ascii_to_Integer (help_name[5], 2);
            End
         Else
            Begin
            menu_level := menu_level - 1;
            Open_Help_File;
            End;
         ch := ' ';
         End;
      End
   Else If not (ch in [';'..'D']) then
      Beeper
   Else
      Begin
      help_name := '';
      line := menu_line;
      x := (page - 1) * 23;
      While line < line_count do
         Begin
         byt := Non_Pos (' ', text_buffer[line + x]);
         If byt > 0 then
            If Ascii_to_Integer(text_buffer[line+x][byt], 2) = Ord(ch)-58 then
               Begin
               work_s := text_buffer[line+x];
               help_name := Copy (work_s, Pos('@', work_s)+1, Length(work_s));
               line := line_count;
               End;
         line := line + 1;
         End;
      If help_name <> '' then
         Begin
         If help_name[1] = '#' then
            Begin
            page := Ascii_to_Integer (help_name[2], 2);
            Find_Menu_Line;
            last_menu_name[menu_level] := '#' + Strng (page, 2)
                                        + '-' + Strng (menu_line, 2);
            End
         Else
            Begin
            valid_name := False;
            Open_Help_File;
            If not valid_name then
               Begin
               Pos_Write (text_page, 24, 17,
                          red, 'No further information available.');
               Delay (2000);
               display_required := False;
               Pos_Write (text_page, 24, 17,
                          red, '                                 ');
               End
            Else
               first_line := 1;
            End;
         End
      Else
         Beeper;
      End;
   End
Else
   If ch <> CR then
      Beeper;
If (display_required) and (help_name <> '') then
   ClrScr;
End;
{.Pa}
Begin
first_line := 1;
New_Page (text_page);
ClrScr;
Display_Page;
Repeat
   Begin
   display_required := True;
   If in_menu then
      Menu_Help_File
   Else
      Text_Help_File;
   If (display_required)
   And (not (ch in [CR, Esc])) then
      Display_Page;
   End
Until (ch = CR)
   Or (ch = Esc);
New_Page (menu_page);
End;

Var
   save_x,
   save_y : Byte;
Begin
ConOutPtr := Ofs (Write_Char);
New (screen_stack);
New (menu_ch_stack);
New (menu_byt_stack);
Where_Cursor (current_page, save_y, save_x);
Save_Menu_Area;
Display_Prompt_Window;
Save_Text_Area;
If ParamCount > 0 then
   Begin
   invoke_from_parm := True;
   help_name := ParamStr (1);
   End
Else
   invoke_from_parm := False;
repeat
   Begin
   menu_level := 0;
   Get_Help_Name;
   If help_name <> '' then
      Display_Help;
   End
until help_name = '';
Restore_Menu_Area;
Restore_Text_Area;
gotoxy (save_x, save_y);
Normal_Cursor;
End.
