{.Title 'IBM PC On_Line Helper With Menu Selection'}
{$C-}
{$V-}
{$R-}
{$K-}
{******************************************************************************
*     IBM PERSONAL COMPUTER ON-LINE HELP V6.1 - For public domain use only    *
*                                                                             *
*       Main routine for memory resident HELP. Requires HELP.INC.             *
*       Compile with max/min dynamic memory = $0200 paragraphs                *
*                                                                             *
*                              David N. Ikle'                                 *
*                              1671 Newport St.                               *
*                              Denver, CO 80220                               *
*                              303-333-9322                                   *
*                                                                             *
*       Re-worked for menu selecting and code optimization.                   *
*                                                                             *
*                              C. H. Thomann                                  *
*                              635 W 39th Terr.                               *
*                              K.C., Mo  64111                                *
*                              816-753-0967                                   *
******************************************************************************}
Program Helper;
Type
  menu_array        = array[1..10] of String[44];

Const
  Our_Scan          : Byte = 94;
  Our_Char          : Byte = 0;
  color_of_frame    : Byte = yellow;
  color_of_header   : Byte = brown;
  color_of_prompt   : Byte = green;
  color_of_text     : Byte = green;
  color_of_keyline  : Byte = cyan;
  color_of_response : Byte = lightgreen;
  top_line          : Byte = 06;
  left_column       : Byte = 18;

  install_message : String [57] =
     'Resident HELP Installed -- Press <Ctrl-F1> to Execute    ';

  menu : menu_array =
    ('                                            ',
     '   IBM PERSONAL COMPUTER ON-LINE HELP V6.1  ',
     '    For public domain use only; 05/15/86    ',
     '                                            ',
     '                                            ',
     '                                            ',
     ' Keywords are names of commands or features ',
     '     Enter ? or HELPER for instructions     ',
     '      Press Enter While Blank to quit       ',
     '                                            ');

  Null = #0;
  CR   = #13;
  Esc  = #27;
  FF   = #12;

  current_page    : Byte = 00;
  write_attribute : Byte = 07;

  menu_page   = 0;
  text_page   = 3;

  max_levels  = 15;    {max number of levels of menu nesting}
  max_rows    = 23;    {max number of text lines in the display}
  max_lines   = 184;   {max number of lines in the text files}

  message_1 : String[51] =
' return; Esc exit; ,,PgUp,PgDn,Home,End scroll';
  message_2 : String[59] =
'Function Key Selects Topic,  return; Esc exits';
{.Pa}
type
  Work_String   = String[80];
  text_array    = array[1..184] of String[80];
  stack_type    = array[1..25] of Array [1..2] of String [79];
  menu_ch_type  = array[1..12] of Array [1..46] of Char;
  menu_byt_type = array[1..12] of Array [1..46] of Byte;
  text_file     = text[$800];

Var
  screen_stack   : ^stack_type;
  menu_ch_stack  : ^menu_ch_type;
  menu_byt_stack : ^menu_byt_type;

  infile         : text_file;

  row,
  line,
  entry_line,
  menu_line,
  page,
  column,
  current_location,
  line_count,
  start_last_page,
  x,
  y,
  line_length,
  byt             : Byte;
  ch              : Char;
  text_buffer     : text_array;
  help_name       : String[36];
  work_s          : String[80];
  valid_name,
  in_menu         : Boolean;

  menu_level      : Byte;
  last_menu_name  : Array [1..max_levels] of String[40];

  mono_screen_page3  : Char absolute $B300:$0000;
  color_screen_page3 : Char absolute $BB00:$0000;
{.Pa}
{$I \Turbo\Incs\RegRec.Var    }
{$I \Turbo\Incs\Cursors.Dos   }
{$I \Turbo\Incs\ReadScrn.Dos  }
{$I \Turbo\Incs\GotoXY.Dos    }
{$I \Turbo\Incs\WhrCrs.Dos    }
{$I \Turbo\Incs\ClrScr.Dos    }
{$I \Turbo\Incs\Max.Fnc       }
{$I \Turbo\Incs\Min.Fnc       }
{$I \Turbo\Incs\UpWord.Fnc    }
{$I \Turbo\Incs\Asci2Int.Fnc  }
{$I \Turbo\Incs\NonPos.Fnc    }
{$I \Turbo\Incs\Remove.Fnc    }
{$I \Turbo\Incs\Strng.Fnc     }
{$I \Turbo\Incs\NonZero.Fnc   }
{$I \Turbo\Incs\Stroke.Fnc    }
{$I \Turbo\Incs\Beep.Prc      }
{$I \Turbo\Incs\Write.Prc     }
{$I \Turbo\Incs\TextColr.Prc  }
{$I \Turbo\Incs\PosWrite.Prc  }
{$I \Turbo\Incs\NewPage.Prc   }
{$I \Turbo\Incs\ScnScrll.Prc  }
{.Nest=00}
{.Pa}
Procedure Save_Menu_Area;
Begin
No_Cursor;
For y := (top_line - 1) to (top_line + 10) do
   For x := (left_column - 1) to (left_column + 44) do
      Read_Screen (current_page, y, x,
                   menu_byt_stack^[y, x], menu_ch_stack^[y, x]);
End;

Procedure Restore_Menu_Area;
Begin
For y := (top_line - 1) to (top_line + 10) do
   For x := (left_column - 1) to (left_column + 44) do
      Pos_Write (menu_page, y, x, menu_byt_stack^[y, x], menu_ch_stack^[y, x]);
End;

Procedure Save_Text_Area;
Begin
Intr ($11, Register_Record);
If (Register_Record.AX and 48) = 48 then
   Move (mono_screen_page3, screen_stack^, 4000)
Else
   Move (color_screen_page3, screen_stack^, 4000);
End;

Procedure Restore_Text_Area;
Begin
Intr ($11, Register_Record);
If (Register_Record.AX and 48) = 48 then
   Move (screen_stack^, mono_screen_page3, 4000)
Else
   Move (screen_stack^, color_screen_page3, 4000);
End;

Procedure Draw_Box (menu_page, row1, column1, row2, column2 : Byte);
Begin
Pos_Write (menu_page, row1, column1, color_of_frame, '');
for column := column1+1 to column2-1 do
   Pos_Write (menu_page, row1, column, color_of_frame,'');
Pos_Write (menu_page, row1, column2, color_of_frame, '');
for row := row1+1 to row2-1 do
   Begin
   Pos_Write (menu_page, row, column1, color_of_frame, '');
   Pos_Write (menu_page, row, column2, color_of_frame, '');
   End;
Pos_Write (menu_page, row2, column1, color_of_frame, '');
for column := column1+1 to column2-1 do
   Pos_Write (menu_page, row2, column, color_of_frame, '');
Pos_Write (menu_page, row2, column2, color_of_frame, '');
End;

Procedure Display_Prompt;
Begin
Pos_Write (menu_page, entry_line, left_column + 8,
           color_of_prompt, 'Enter keyword');
Pos_Write (menu_page, entry_line, left_column + 24, color_of_frame, '==>');
End;

Procedure Display_Prompt_Window;
Begin
Draw_Box(menu_page, top_line-1, left_column-1, top_line+10, left_column+44);
For row := 1 to 7 do
   Pos_Write (menu_page, row+top_line-1, left_column,
              color_of_header, menu[row]);
For row := 8 to 11 do
   Pos_Write (menu_page, row+top_line-1, left_column,
              color_of_text, menu[row]);
entry_line := top_line + 4;
End;

Procedure Write_String;
Begin
Pos_Write (menu_page, entry_line, column + 1, color_of_response, help_name);
gotoxy (column + current_location, entry_line);
End;
{.Pa}
Procedure Move_Menu_Display;
Begin
work_s := 'Num Lock and KeyPad to Move Menu';
Move (work_s[1], menu[6][6], 32);
No_Cursor;
Pos_Write (menu_page, entry_line, left_column, color_of_header, menu[6]);
Repeat
   Begin
   If Get_Stroke (ch) = extended then
      Begin
      If ch <> ';' then
         Beep;
      End
   Else If not (ch in ['1'..'9']) then
      Beep
   Else
      Begin
      Restore_Menu_Area;
      Case ch of
         '1' : Begin
               top_line    := 12;
               left_column := 2;
               End;
         '2' : Begin
               If top_line < 12 then
                  top_line := top_line + 1
               Else
                  Beep;
               End;
         '3' : Begin
               top_line    := 12;
               left_column := 33;
               End;
         '4' : Begin
               If left_column > 2 then
                  left_column := left_column - 1
               Else
                  Beep;
               End;
         '5' : Begin
               top_line    := 6;
               left_column := 18;
               End;
         '6' : Begin
               If left_column < 33 then
                  left_column := left_column + 1
               Else
                  Beep;
               End;
         '7' : Begin
               top_line    := 2;
               left_column := 2;
               End;
         '8' : Begin
               If top_line > 2 then
                  top_line := top_line - 1
               Else
                  Beep;
               End;
         '9' : Begin
               top_line    := 2;
               left_column := 34;
               End;
         End;
      Save_Menu_Area;
      Display_Prompt_Window;
      column := left_column + 27;
      End;
   End
Until ch = ';';
FillChar (menu[6][6], 32, ' ');
Pos_Write (menu_page, entry_line, left_column, black, menu[6]);
Normal_Cursor;
Display_Prompt;
Write_String;
End;

{.Pa}
Procedure Get_Name;
var
  inserting : Boolean;

Procedure Write_Character;
Begin
If current_location <= 8 then
   Begin
   If inserting then
      Begin
      Insert (ch, help_name, current_location);
      Delete (help_name, 8, 1);
      End
   Else
      help_name[current_location] := ch;
   current_location := current_location + 1;
   Write_String;
   End
Else
   Beep;
End;

Procedure Escape;
Begin
current_location := 1;
FillChar (help_name[1], 8, ' ');
Write_String;
End;

Procedure Home;
Begin
current_location := 1;
Write_String;
End;

Procedure Lt_Arrow;
Begin
If current_location > 1 then
   Begin
   current_location := current_location - 1;
   Write_String;
   End
Else
   Beep;
End;

Procedure Rt_Arrow;
Begin
If current_location < 8 then
   Begin
   current_location := current_location + 1;
   Write_String;
   End
Else
   Beep;
End;

Procedure End_Key;
Begin
current_location := Max (1, Non_Zero (Pos (' ', help_name), 9) - 1);
Write_String;
End;

Procedure Insert_Char;
Begin
If inserting then
   Begin
   inserting := False;
   Normal_Cursor;
   End
Else
   Begin
   inserting := True;
   Insert_Cursor;
   End;
End;
{.Pa}
Procedure Delete_Char;
Begin
Delete (help_name, current_location, 1);
help_name := help_name + ' ';
write_String;
End;

Procedure Back_Space;
Begin
If current_location > 1 then
   Begin
   delete(help_name, current_location-1, 1);
   current_location := current_location - 1;
   help_name := help_name + ' ';
   write_String;
   End
Else
   Beep;
End;

Begin
column := left_column + 27;
current_location := 1;
inserting := False;
help_name := Copy (help_name + '        ', 1, 8);
Write_String;
Repeat
   Begin
   If Get_Stroke (ch) = extended then
      Case Ord (ch) of
         27 : Escape;
         59 : Move_Menu_Display;
         71 : Home;
         75 : Lt_Arrow;
         77 : Rt_Arrow;
         79 : End_Key;
         82 : Insert_Char;
         83 : Delete_Char;
         Else Beep;
         End
   Else
      Begin
      Case Ord (ch) of
          8 : Back_Space;
         13 : ;
         42 : Begin
              If current_location > 1 then
                 Beep
              Else
                 Begin
                 help_name := '###';
                 ch := CR;
                 End;
              End;
         63 : Begin
              help_name := 'HELPER';
              Pos_Write (menu_page, entry_line, column + 1,
                         color_of_response, '?');
              ch := CR;
              End;
     48..57,                        {numeric digits}
     65..90,                        {upper case letters}
    97..122,                        {lower case letters}
  33,35..41,
   45,64,95,
 96,123,125 : Write_Character;      {special Characters}
         Else Beep;
         End;
      If current_location > 8 then
         ch := CR;
      End;
   End
Until ch = CR;
help_name := Remove (help_name, ' ');
End;
{.Pa}
Procedure Find_Menu_Line;
Begin
menu_level := Min (menu_level + 1, max_levels);
x := (page - 1) * 23;
For line := 1 to max_rows do
   Begin
   work_s := UpWord (Copy (text_buffer[x + line], 1, 5));
   If work_s = 'MENU:' then
      menu_line := line + 1;
   End;
End;

Procedure Load_Help_File;
Begin
line_count := 0;
line       := 0;
in_menu    := False;
Repeat
   Begin
   line_count := line_count + 1;
   line := line + 1;
   If line > max_rows then
      line := 1;
   FillChar (text_buffer[line_count], 81, Null);
   Readln (infile, text_buffer[line_count]);
   If text_buffer[line_count][1] = FF then
      Begin
      x := line_count;
      line_count := line_count + max_rows - line;
      While x <= line_count do
         Begin
         FillChar (text_buffer[x], 81, Null);
         x := x + 1;
         End;
      line := 0;
      End
   Else
      Begin
      work_s := UpWord (Copy (text_buffer[line_count], 1, 5));
      If work_s = 'MENU:' then
         in_menu := True;
      End;
   End
Until EOF(infile)
   Or (line_count >= max_lines);
If in_menu then
   Begin
   page    := 1;
   Find_Menu_Line;
   last_menu_name[menu_level] := help_name;
   End;
Close (infile);
If line_count <= max_rows then
   start_last_page := 1
Else
   start_last_page := line_count - max_rows + 1;
End;
{.Pa}
Procedure Open_Help_File;
Begin
If Pos ('.', help_name) = 0 then
   help_name := help_name + '.###';
Assign (infile, help_name);
{$I-} Reset (infile) {$I+};
If IOResult <> 0 then
   Beep
Else
   Begin
   valid_name := True;
   Load_Help_File;
   End;
End;

Procedure Get_Help_Name;
Begin
Display_Prompt;
Normal_Cursor;
valid_name := false;
help_name := '';
repeat
   Begin
   x := Pos ('.', help_name);
   If x > 0 then
      Delete (help_name, x, Length (help_name));
   Get_Name;
   If (help_name = '') then
      valid_name := true
   Else
      Open_Help_File;
   End
until valid_name;
No_Cursor;
End;
{.Pa}
Procedure Display_Help;
var
  first_line       : Byte;
  display_required : Boolean;

Procedure Display_Line;
Begin
line := first_line + row - 1;
work_s := text_buffer[line];
If in_menu then
   Begin
   x := Pos ('@', work_s);
   If x > 0 then
      Delete (work_s, x, Length(work_s));
   End;
Writeln (work_s);
End;

Procedure Display_Page;
Begin
If in_menu then
   Begin
   first_line := ((page - 1) * max_rows) + 1;
   For row := 1 to (menu_line - 1) do
      Pos_Write (text_page, row, 1,
                 color_of_header, text_buffer[first_line + row - 1]);
   Writeln;
   End
Else
   row := 0;
TextColor (color_of_text);
Repeat
   Begin
   row := row + 1;
   Display_Line;
   End
Until (row >= max_rows) Or (line >= line_count);
If in_menu then
   Begin
   work_s := message_2 + '; Menu level #' + Strng (menu_level, 2) + '.';
   Pos_Write (text_page, 25, 1, color_of_keyline, work_s);
   End
Else
   Begin
   work_s := message_1;
   If menu_level > 0 then
      work_s := work_s + '; F# back #menus';
   work_s := work_s + ' ';
   Pos_Write (text_page, 25, 1, color_of_keyline, work_s);
   TextColor (color_of_text);
   If line >= line_count then
      Write ('<EndOfFile>')
   Else
      Write ('<Continued>');
   End;
End;

Procedure Beeper;
Begin
Beep;
display_required := False;
End;
{.Pa}
Procedure Scroll (way : Integer);
Begin
Scroll_Screen_Area (1, 1, 80, max_rows, way);
first_line := first_line + way;
If way > 0 then
   Begin
   GotoXY (1, max_rows);
   row := max_rows;
   End
Else
   Begin
   GotoXY (1, 1);
   row := 1;
   End;
Display_Line;
display_required := False;
End;

Procedure Text_Help_File;
Begin
If Get_Stroke (ch) = extended then
   Begin
   Case Ord (ch) of
      27     : help_name := '';                       {escape}
      59..68 : If menu_level = 0 then                 {Function key}
                  Beeper
               Else
                  Begin
                  menu_level := Max (1, menu_level-(Ord(ch)-59));
                  While last_menu_name[menu_level][1] = '#' do
                     menu_level := menu_level - 1;
                  help_name  := last_menu_name [menu_level];
                  menu_level := menu_level - 1;
                  Open_Help_File;
                  End;
      71     : If first_line <= 1 then                {home key}
                  Beeper
               Else
                  first_line := 1;
      72     : If first_line <= 1 then                {up arrow}
                  Beeper
               Else
                  Scroll (-1);
      80     : If first_line >= start_last_page then  {down arrow}
                  Beeper
               Else
                  Scroll (+1);
      73     : If first_line <= 1 then                {page up}
                  Beeper
               Else
                  first_line := max(1,first_line-max_rows);
      81     : If first_line >= start_last_page then  {page down}
                  Beeper
               Else
                  first_line := min(start_last_page,first_line+max_rows);
      79     : If first_line >= start_last_page then  {End key}
                  Beeper
               Else
                  first_line := start_last_page;
          Else Beeper;
          End;
          If display_required then
             ClrScr;
      End
Else
   If ch <> Cr then
      Beeper;
End;
{.Pa}
Procedure Menu_Help_File;
Begin
If Get_Stroke (ch) = extended then
   Begin
   If ch = Esc then
      Begin
      If menu_level = 1 then
         help_name := ''
      Else
         Begin
         menu_level := menu_level - 1;
         help_name  := last_menu_name [menu_level];
         If help_name[1] = '#' then
            Begin
            page := Ascii_to_Integer (help_name[2], 2);
            menu_line := Ascii_to_Integer (help_name[5], 2);
            End
         Else
            Begin
            menu_level := menu_level - 1;
            Open_Help_File;
            End;
         ch := ' ';
         End;
      End
   Else If not (ch in [';'..'D']) then
      Beeper
   Else
      Begin
      help_name := '';
      line := menu_line;
      x := (page - 1) * 23;
      While line < line_count do
         Begin
         byt := Non_Pos (' ', text_buffer[line + x]);
         If byt > 0 then
            If Ascii_to_Integer(text_buffer[line+x][byt], 2) = Ord(ch)-58 then
               Begin
               work_s := text_buffer[line+x];
               help_name := Copy (work_s, Pos('@', work_s)+1, Length(work_s));
               line := line_count;
               End;
         line := line + 1;
         End;
      If help_name <> '' then
         Begin
         If help_name[1] = '#' then
            Begin
            page := Ascii_to_Integer (help_name[2], 2);
            Find_Menu_Line;
            last_menu_name[menu_level] := '#' + Strng (page, 2)
                                        + '-' + Strng (menu_line, 2);
            End
         Else
            Begin
            valid_name := False;
            Open_Help_File;
            If not valid_name then
               Begin
               Pos_Write (text_page, 24, 17,
                          red, 'No further information available.');
               Delay (2000);
               display_required := False;
               Pos_Write (text_page, 24, 17,
                          red, '                                 ');
               End
            Else
               first_line := 1;
            End;
         End
      Else
         Beeper;
      End;
   End
Else
   If ch <> CR then
      Beeper;
If (display_required) and (help_name <> '') then
   ClrScr;
End;
{.Pa}
Begin
first_line := 1;
New_Page (text_page);
ClrScr;
Display_Page;
Repeat
   Begin
   display_required := True;
   If in_menu then
      Menu_Help_File
   Else
      Text_Help_File;
   If (display_required)
   And (not (ch in [CR, Esc])) then
      Display_Page;
   End
Until (ch = CR)
   Or (ch = Esc);
New_Page (menu_page);
End;

Procedure Run_Help;
Var
   save_x,
   save_y : Byte;
Begin
Where_Cursor (current_page, save_y, save_x);
Save_Menu_Area;
Display_Prompt_Window;
Save_Text_Area;
repeat
   Begin
   menu_level := 0;
   Get_Help_Name;
   If help_name <> '' then
      Display_Help;
   End
until help_name = '';
Restore_Menu_Area;
Restore_Text_Area;
gotoxy (save_x, save_y);
Normal_Cursor;
End;
{.Pa}
{----------------------------------------------------------------------------}
{        Memory resident procedures by Lane Ferris, The Hunters Helper       }
{                           Stayres Version 3.2C                             }
{----------------------------------------------------------------------------}
  const
    User_Int        = $64;                   {user interrupt}
    Kybrd_Int       = $16;                   {keyboard interrupt}
  Type
    Regtype     = record Ax,Bx,Cx,Dx,Bp,Si,Di,Ds,Es,Flags:integer  end;
    HalfRegtype = record Al,Ah,Bl,Bh,Cl,Ch,Dl,Dh:byte              end;
  Const
      Regs   : regtype = (Ax:0;Bx:0;Cx:0;Dx:0;Bp:0;Si:0;Di:0;Ds:0;Es:0;Flags:0);
      OurDseg: integer = 0;            {Our Data Segment Value             }
      OurSseg: integer = 0;            {Our Stack Segment Value            }
      DosSseg: integer = 0;            {Dos Stack Segment Value            }
      Inuse  : Boolean = false;        {Recursion flag                     }
      User_IntIP : integer = 0;        {Pointer to Original IP Int value   }
      User_IntCs : integer = 0;        {Pointer to Original Cs Int value   }
      StackSize  : integer = 0;        {Current User/or Dos Stack word size}
    Var
      SaveRegs                      : regtype;
      HalfRegs                      : halfregtype absolute regs;
      Terminate_flag                : boolean ;
{----------------------------------------------------------------------------}
Procedure Process_Interupt;          {  Process User Interrupt                   }
{ Prepare Stack ... }
{.NoList}
Begin
  Inline (
   $80/$FC/$00/                        {Cmp Ah,00     If Char request,       }
   $74/$07/                            {Je   ChrRqst  enter Staysave code    }
   $5D/$5D/                            {Pop  Bp/Pop Bp    Restore Bp         }
   $2E/
   $FF/$2E/User_IntIP/                 {Jmp Far Cs:[User_IntIp]              }
{ChrRqst: }
    $FA /                              {  Cli       Stop all interrupts       }
                                       { Bp and Sp aready saved at Begin Stmt }
    $55/                               {Push   Bp  Save again for Regpak      }
    $BD/Regs/                          {Mov    Bp,offset REGS}
    $2E/$89/$46/$00/                   {CS:Mov [Bp+0],AX}
    $2E/$89/$5E/$02/                   {Cs:Mov [Bp+2],Bx}
    $2E/$89/$4E/$04/                   {CS:Mov [Bp+4],CX}
    $2E/$89/$56/$06/                   {CS:Mov [Bp+6],DX}
    $2E/$8F/$46/$08/                   {Pop    Cs:[Bp+8] Fetch Bp from stack  }
    $2E/$89/$76/$0A/                   {CS:Mov [Bp+A],SI}
    $2E/$89/$7E/$0C/                   {CS:Mov [Bp+C],DI}
    $2E/$8C/$5E/$0E/                   {CS:Mov [Bp+E],DS}
    $2E/$8C/$46/$10/                   {CS:Mov [Bp+10],ES}
    $9C/                               {PUSHF  put Flags on stack to retrieve }
    $2E/$8F/$46/$12/                   {POP Cs:[Bp+12]}
     $2E/$80/$3E/Inuse/$01/   {Cmp  Cs:[Inuse],1                          }
     $74/$67/                 {Je   ReCurin             -J-U-M-P-         }
     $2E/$8C/$16/DosSSeg/     {Mov  Cs:DosSSeg,SS Save Dos Stack Segment    }
     $8C/$D6/                 {Mov  Si,SS         If this is our Stack Seg  }
     $8E/$C6/                 {Mov  Es,Si         Get Dos StackSeg          }
     $2E/$8E/$16/OurSSeg/     {Mov  SS,Cs:OurSSeg Get our Stack segment     }
     $2E/$8E/$1E/OurDseg/     {Mov  Ds,Cs:Our_Ds  Setup our Data Segment    }
     $2E/$3B/$36/OurSSeg/     {Cmp  Si,Cs:OurSSeg ..use current Stack ptr   }
     $89/$E6/                 {Mov  Si,Sp         ..value..else reset stack }
     $74/$05/                 {Je   $+5           ..to original Turbo stack }
     $3E/$8B/$36/$74/$01/     {Mov  Si,Ds:[174]   ..(cf. code at B2B 3.0x)  }
     $87/$F4/                 {Xchg Sp,Si         Set new  Stack Pointer    }
                                          { Save Dos/User regs for Exit     }
     $2E/$FF/$76/$00/         {Push [Bp+0]  Save Ax                         }
     $2E/$FF/$76/$02/         {Push [Bp+2]  Save Bx                         }
     $2E/$FF/$76/$04/         {Push [Bp+4]  Save Cx                         }
     $2E/$FF/$76/$06/         {Push [Bp+6]  Save Dx                         }
                              {Push [Bp+8]  Save Bp                         }
     $2E/$FF/$76/$0A/         {Push [Bp+A]  Save Si                         }
     $2E/$FF/$76/$0C/         {Push [Bp+C]  Save Di                         }
     $2E/$FF/$76/$0E/         {Push [Bp+E]  Save Ds                         }
     $2E/$FF/$76/$10/         {Push [Bp+10] Save Es                         }
     $29/$C9/                 {Sub  Cx,Cx  Find minimum of current stack    }
     $29/$F1/                 {Sub  Cx,Si  size or 40 words to save         }
     $D1/$E9/                 {Shr  Cx,1   Stackbytes/2 for words           }
     $83/$F9/$40/             {Cmp  Cx,+40 This keeps up from overrunning   }
     $7E/$03/                 {Jle  $+3    the Stack Segment when it is less}
     $B9/$40/$00/             {Mov  Cx,40  than Dos stack size              }
     $2E/$89/$0E/StackSize/   {Mov  Cs:StackSize,Cx Save current stack size }
 {Restack:}
     $26/$FF/$34/             {Push Es:[Si] Our Stack := Dos Es:Si          }
     $46/$46/                 {Inc  Si/Inc Si Get Next Dos Stack Word       }
     $E2/$F9/                 {Loop to Restack                              }
     $2E/$8E/$16/OurSSeg/     {Mov  SS,Cs:OurSSeg Set up our Stack          }
     $56/                     {Push Si            Save bottom of Dos Stack  }
     $2E/$8C/$5E/$0E/         {Mov  Cs:[Bp+E],Ds  Set New Data Segmt in regs}
{Recurin                                            Jump here if Recursion  }
     $FB                      {Sti Enable Interrupts                        }
       ) ;
{.List}
Intr (User_Int, Regs);             { Use the DOS replaced interrupt}
                                   { Get Key from Keyboard         }
If (Halfregs.Ah = Our_Scan) then
   If (Halfregs.Al = Our_Char) then   { Separate tests for efficiency.}
      If (not InUse) then             { Must be OUR key and not busy  }
         Begin
         InUse := true;                    { "dont clobber saved stack"      }
         run_help ;                        { CALL USER PROGRAM               }
         While (not Keypressed);           { Get input key for the users     }
            Repeat
               SaveRegs.Ax := 0 ;          {           interrupted program   }
               Intr(User_Int,SaveRegs);    { Get the Scancode                }
               Regs.Ax := SaveRegs.Ax;
               If (HalfRegs.Ah = Our_Scan)
               And (HalfRegs.Al = Our_Char) then
                  Beep;
            until (HalfRegs.Ah <> Our_Scan)
              And (HalfRegs.Al <> Our_Char);
        InUse := false;                   { ok to restore interrupted stack }
        End;
{ Restore stack ... }
{.NoList}
    inline(
    $BD/Regs/                          {Mov    Bp,offset REGS}
    $2E/$8B/$46/$00/                   {CS:Mov Ax,[Bp+0]}
    $2E/$8B/$5E/$02/                   {Cs:Mov Bx,[Bp+2]}
    $2E/$8B/$4E/$04/                   {CS:Mov Cx,[Bp+4]}
    $2E/$8B/$56/$06/                   {CS:Mov Dx,[Bp+6]}
    $2E/$8B/$76/$0A/                   {CS:Mov Si,[Bp+A]}
    $2E/$8B/$7E/$0C/                   {CS:Mov Di,[Bp+C]}
    $2E/$8E/$5E/$0E/                   {CS:Mov DS,[Bp+E]}
    $2E/$8E/$46/$10/                   {CS:Mov ES,[Bp+10]}
    $2E/$FF/$76/$12/                   {Push Cs:[Bp+12]}
    $EB/$01/                           {JMP $+3 Skip over IRET   }
    $CF/                               {IRET    POP IP/CS/Flags  }
    $0E/                               {PUSH CS Make a return    }
    $E8/$FB/$FF/                       {CALL CS:$-2 Pop the Flags}
     $2E/$80/$3E/Inuse/$01/   {Cmp  byte ptr Cs:[Inuse],1                 }
     $74/$25/                 {Je   ReCurOut   J-U-M-P                    }
      $FA /                   { Cli      ; Stop all interrupts            }
    $5E/                     {Pop Si     Bottom of Dos Stack              }
    $2E/
    $8B/$0E/StackSize/       {Mov Cx,Cs:StackSize Saved Stack Words       }
    $2E/$8E/$06/DosSSeg/     {Mov ES,Cs:DosSSeg Get Dos StackSegment      }
  {Restack:}
    $4E/$4E/                 {Dec Si/Dec Si     Backup Dos Stack          }
    $26/$8F/$04/             {Pop Es:[Si]       Dos Stack := Our Stack    }
    $E2/$F9/                 {Loop to Restack                             }
    $89/$F5/                 {Mov Bp,Si         Save Dos Sp across Pops   }
    $07/                     {Pop  Es                                     }
    $1F/                     {Pop  Ds                                     }
    $5F/                     {Pop  Di                                     }
    $5E/                     {Pop  Si                                     }
    $5A/                     {Pop  Dx                                     }
    $59/                     {Pop  Cx                                     }
    $5B/                     {Pop  Bx                                     }
    $44/$44/                 {Inc sp/Inc sp Thow old Ax value away        }
    $89/$EC/                  {Mov  Sp,Bp         Setup Dos Stack Ptr     }
    $2E/$8E/$16/DosSSeg/      {Mov  SS,Cs:DosSSeg Give back Dos Stack     }
{RecurOut                                 Clean up the Stack              }
    $5D/                               {Pop Bp     Throw away old dos Sp  }
    $BD/Regs/                          {Mov    Bp,offset REGS             }
    $2E/$FF/$76/$12/                   {Push Cs:[Bp+12]                   }
    $EB/$01/                           {JMP $+3 Skip over IRET   }
    $CF/                               {IRET    POP IP/CS/Flags  }
    $0E/                               {PUSH CS Make a return    }
    $E8/$FB/$FF/                       {CALL CS:$-2 Pop the Flags}
    $5D/                               {Pop Bp  Retrieve old BP  }
    $FB/                               {Sti     Enable interrupts}
    $CA/$02/$00                        {Ret Far 002              }
        );
{.List}
End;
{.Pa}
Var
   abort_code : Byte;
Begin
ConOutPtr := Ofs (Write_Char);
TextColor (green);
Writeln ('Installing Resident HELP ...');
Writeln ('   by D.N.Inkle''/C.H.Thomann');
Writeln;
For row := 2 to 4 do
   Writeln (menu[row]);
InUse   := false;
OurDseg := Dseg;           { Save the Data Segment Address for Interrupts }
OurSseg := Sseg;           { Save our Stack Segment for Interrupts        }
Terminate_Flag := false ;
SaveRegs.Es := 00;       {Clear for Dos 3.0 bug}
SaveRegs.Ax := $3500 + User_Int;
Intr ($21,SaveRegs);
If SaveRegs.Es <> $00 then
   abort_code := 1
Else
   Begin
   If not ((memavail < 0) or (memavail >= $0100)) then
      abort_code := 2
   Else
      Begin
      abort_code := 0;
      New (screen_stack);
      New (menu_ch_stack);
      New (menu_byt_stack);
      SaveRegs.Ax := $3500 + Kybrd_Int;
      Intr ($21,SaveRegs);      { get the address of keyboard interrupt }
      SaveRegs.Ax := $2500 + User_Int;
      SaveRegs.Ds := SaveRegs.Es;
      SaveRegs.Dx := SaveRegs.Bx;
      Intr ($21,SaveRegs);      { set user-int to point to keyboard int }
      SaveRegs.Ax := $2500 + Kybrd_Int;
      SaveRegs.Ds := Cseg;
      SaveRegs.Dx := Ofs(Process_Interupt);
      Intr ($21,SaveRegs);      { set keyboard int to point to "Process-Intr" }
      User_IntIP := MemW[0:User_Int * 4 ];    { Location of User Interrupt Ip }
      User_IntCs := MemW[0:User_Int * 4 +2];  { Location of User Interrupt Cs }
      Writeln (install_message);              { Pass return code of zero      }
      SaveRegs.Ax := $3100 ;                  { Terminate and Stay Resident   }
      SaveRegs.Dx := MemW [Cseg-1:0003] ;     { Prog_Size from Allocation Blk }
      Intr ($21,SaveRegs);
      End;
   End;
If abort_code <> 0 then
   Begin
   Write ('Installation ABORTED -- ', Chr (7));
   Case abort_code of
      1 : Writeln ('User Interrupt Taken');
      2 : Writeln ('Insufficient Memory');
      End;
   End;
End.
