Program Helper_Installation;
Const
   Null = #00;
   CR   = #13;
   Esc  = #27;

   position_of_invoker  = $2C9F;
   position_of_colors   = $2CA1;
   position_of_location = $2CA7;
   position_of_blurb    = $2CCB;

Type
   Work_String = String [80];

Type
   title_array = Array [1..6] of String[8];

Const
   color_title : title_array =
   ( 'frame', 'header', 'prompt', 'text', 'keyline', 'response');

Var
   color     : Array [1..6] of Byte;
   new_color : String [20];
   scan_title: String [10];
   row,
   column,
   scan_code,
   scan_char : Byte;
   x, y, z,
   byt,
   byt2 : Byte;
   choice,
   ch   : Char;
   i, j : Integer;
   s    : String [40];
   correct,
   there_has_been_activity : Boolean;

   Com_File : File of Byte;

{$I \Turbo\Incs\RegRec.Var  }
{$I \Turbo\Incs\Stroke.Fnc  }
{$I \Turbo\Incs\Strng.Fnc   }
{$I \Turbo\Incs\Asci2Int.Fnc}
{$I \Turbo\Incs\Upword.Fnc  }
{$I \Turbo\Incs\Remove.Fnc  }
{$I \Turbo\Incs\Beep.Prc    }

Procedure Error (M : Work_String);
Begin
Write (M);
{$I-} Close (Com_File); {$I+}
Halt;
End;

Procedure Doublet (d1, d2 : Work_String);
Begin
TextColor (brown);
Write (d1);
TextColor (yellow);
Write (d2);
End;

Function Get_Byte (position : Integer) : Byte;
Var
   b : byte;
Begin
Seek (Com_File, position);
Read (Com_File, b);
Get_Byte := b;
End;

Procedure Put_Byte (b : Byte; position : Integer);
Begin
Seek (Com_File, position);
Write (Com_File, b);
End;

Procedure Check_Out (single : Byte; what : Work_String);
Var
   x, y : Byte;
Begin
correct := True;
TextColor (brown);
If single = 1 then
   Write ('Is this')
Else
   Write ('Are these');
Write (' ', what, ' correct? (Y/N) ');
x := WhereX;
y := WhereY;
Repeat
   Begin
   GotoXY (x, y);
   Read (kbd, ch);
   Write (ch);
   If not (ch in ['N', 'Y', 'n', 'y']) then
      Beep;
   End
Until ch in ['N', 'Y', 'n', 'y'];
If ch in ['N', 'n'] then
   correct := False;
End;

Procedure Sub_Header (what1, what2 : Work_String);
Begin
ClrScr;
Writeln ('Enter ', what1, ' of desired ', what2, ', or <CR> to bypass.');
Writeln;
End;

Procedure Modify_Colors;
Function Color_Name (which : Byte) : Work_String;
Begin
TextColor (which);
Case which of
   0  : Color_Name := 'Black';
   1  : Color_Name := 'Blue';
   2  : Color_Name := 'Green';
   3  : Color_Name := 'Cyan';
   4  : Color_Name := 'Red';
   5  : Color_Name := 'Magenta';
   6  : Color_Name := 'Brown';
   7  : Color_Name := 'LightGray';
   8  : Color_Name := 'DarkGray';
   9  : Color_Name := 'LightBlue';
   10 : Color_Name := 'LightGreen';
   11 : Color_Name := 'LightCyan';
   12 : Color_Name := 'LightRed';
   13 : Color_Name := 'LightMagenta';
   14 : Color_Name := 'Yellow';
   15 : Color_Name := 'White';
   End;
End;

Function Is_Color (which : Work_String; Var color : Byte) : Boolean;
Begin
Is_Color := True;
s := UpWord (which);
If s = 'BLACK' then
   color := 0
Else If s = 'BLUE' then
   color := 1
Else If s = 'GREEN' then
   color := 2
Else If s = 'CYAN' then
   color := 3
Else If s = 'RED' then
   color := 4
Else If s = 'MAGENTA' then
   color := 5
Else If s = 'BROWN' then
   color := 6
Else If s = 'LIGHTGRAY' then
   color := 7
Else If s = 'DARKGRAY' then
   color := 8
Else If s = 'LIGHTBLUE' then
   color := 9
Else If s = 'LIGHTGREEN' then
   color := 10
Else If s = 'LIGHTCYAN' then
   color := 11
Else If s = 'LIGHTRED' then
   color := 12
Else If s = 'LIGHTMAGENTA' then
   color := 13
Else If s = 'YELLOW' then
   color := 14
Else If s = 'WHITE' then
   color := 15
Else
   Is_Color := False;
End;

Begin
Repeat
   Begin
   For x := 1 to 6 do
      color[x] := Get_Byte (position_of_colors + x - 1);
   Sub_Header ('name', 'color');
   x := 1;
   While x < 7 do
      Begin
      TextColor (Brown);
      Write ('Current color of ', color_title[x], ' is ',
             Color_Name(color[x]));
      TextColor (Brown);
      Write (' : ');
      Readln (new_color);
      If new_color <> '' then
         Begin
         If not Is_Color (new_color, z) then
            Begin
            Beep;
            x := x - 1;
            End
         Else
            Begin
            there_has_been_activity := True;
            color[x] := z;
            End;
         End;
      x := x + 1;
      End;
   Writeln;
   For x := 1 to 6 do
      Begin
      TextColor (Brown);
      Writeln ('Current color of ', color_title[x], ' is ', Color_Name(color[x]));
      End;
   Check_Out (2, 'colors');
   End
Until correct;
End;

Procedure Modify_Position;
Begin
Repeat
   Begin
   Sub_Header ('co-ordinate', 'position');
   row := Get_Byte (position_of_location);
   column := Get_Byte (position_of_location + 1);
   Repeat
      Begin
      Write ('Row of upper left corner of menu is ', Strng (row, 2), ' : ');
      Readln (s);
      If s = '' then
         i := row
      Else
         Begin
         Val (s, i, j);
         If (j <> 0)
         Or (not (i in [2..12])) then
            Beep
         Else
            Begin
            there_has_been_activity := True;
            row := i;
            End;
         End;
      End
   Until i in [2..12];
   Repeat
      Begin
      Write ('Column of upper left corner of menu is ',
             Strng (column, 2), ' : ');
      Readln (s);
      If s = '' then
         i := column
      Else
         Begin
         Val (s, i, j);
         If (j <> 0)
         Or (not (i in [2..34])) then
            Beep
         Else
            Begin
            there_has_been_activity := True;
            column := i;
            End;
         End;
      End
   Until i in [2..34];
   Writeln;
   Writeln ('Menu upper left corner positioned at [',
            Strng (row, 2), ',', Strng (column, 2), ']');
   Check_Out (2, 'positions');
   End
Until correct;
End;

Procedure Modify_KeyStroke;
Function Scan_Code_Title (scanner, scanned : Byte) : Work_String;
Function Which_Shift (scanned : Byte) : Work_String;
Begin
Case scanned of
   0  : Which_Shift := '<Alt>-';
   Else Which_Shift := '<Cntl>-';
   End;
End;

Function Letter (which : Byte) : Work_String;
Const
   Alphabet : String [26] = 'QWERTYUIOPASDFGHJKLZXCVBNM';
Begin
Letter := Alphabet [which];
End;

Function F_Key (which : Byte) : Work_String;
Begin
Case which of
   1  : F_Key := 'F1';
   2  : F_Key := 'F2';
   3  : F_Key := 'F3';
   4  : F_Key := 'F4';
   5  : F_Key := 'F5';
   6  : F_Key := 'F6';
   7  : F_Key := 'F7';
   8  : F_Key := 'F8';
   9  : F_Key := 'F9';
   10 : F_Key := 'F10';
   End;
End;

Begin
Case scanner of
   16..25   : Scan_Code_Title := Which_Shift (scanned) + Letter (scanner - 15);
   30..38   : Scan_Code_Title := Which_Shift (scanned) + Letter (scanner - 19);
   44..50   : Scan_Code_Title := Which_Shift (scanned) + Letter (scanner - 24);
   84..93   : Scan_Code_Title := '<Shft>-' + F_Key (scanner - 83);
   94..103  : Scan_Code_Title := '<Cntl>-' + F_Key (scanner - 93);
   104..113 : Scan_Code_Title := '<Alt>-' + F_Key (scanner - 103);
   Else       Scan_Code_Title := '';
   End;
End;

Begin
Repeat
   Begin
   Sub_Header ('key combination', 'scan code');
   Writeln ('Available scan-codes are :');
   Writeln ('          <Shft>-F1 thru <Shft>-F10');
   Writeln ('          <Cntl>-F1 thru <Cltl>-F10');
   Writeln ('          <Alt>-F1  thru <Alt>-F10');
   Writeln ('          <Cntl>-A  thru <Cntl>-Z');
   Writeln ('          <Alt>-A   thru <Alt>-Z');
   Writeln;
   scan_code := Get_Byte (position_of_invoker);
   scan_char := Get_Byte (position_of_invoker + 1);
   Repeat
      Begin
      scan_title := Scan_Code_Title (scan_code, scan_char);
      TextColor (brown);
      Write ('Keystroke Scan Code value is ',
             scan_code:3, '/', scan_char:3, ' ');
      TextColor (yellow);
      Write (scan_title);
      TextColor (brown);
      Write (' : ');
      Register_Record.AX := 0;
      Intr ($16, Register_Record);
      Writeln;
      If (Register_Record.A_H = 28)
      And (Register_Record.A_L = 13) then
         scan_title := ' '
      Else
         Begin
         If (Register_Record.A_H in [16..25, 30..38, 44..50])
         And (Not (Register_Record.A_L in [0..26])) then
            Beep
         Else
            Begin
            scan_title := Scan_Code_Title (Register_Record.A_H,
                                           Register_Record.A_L);
            If scan_title = '' then
               Beep
            Else
               Begin
               there_has_been_activity := True;
               TextColor (brown);
               Write ('New scan code should be ');
               TextColor (yellow);
               Writeln (scan_title);
               scan_code := Register_Record.A_H;
               scan_char := Register_Record.A_L;
               End;
               Check_Out (1, 'scan-code');
            End;
         End;
      End
   Until scan_title <> '';
   End
Until correct;
End;

Procedure Update_Com;
Begin
If there_has_been_activity then
   Begin
   TextColor (yellow);
   Writeln ('Updating');
   For x := 1 to 6 do
      Put_Byte (color[x], position_of_colors + x - 1);
   Put_Byte (row, position_of_location);
   Put_Byte (column, position_of_location + 1);
   Put_Byte (scan_code, position_of_invoker);
   Put_Byte (scan_char, position_of_invoker + 1);
   s[1] := '0';
   x := 0;
   While s[1] <> ' ' do
      Begin
      x := x + 1;
      s[1] := Chr (Get_Byte (position_of_blurb + x - 1));
      End;
   s := '               ';
   y := 1;
   For x := x to 24 do
      Begin
      s[y] := Chr (Get_Byte (position_of_blurb + x - 1));
      y := y + 1;
      End;
   textcolor (green);
   For x := 1 to Length(scan_title) do
      Put_Byte (Ord(scan_title[x]), position_of_blurb + x - 1);
   For x := x to 24 do
      Begin
      Put_Byte (Ord(s[1]), position_of_blurb + x);
      Delete (s, 1, 1);
      End;
   TextColor (brown);
   Writeln;
   If scan_title <> '         ' then
      Begin
      Write ('The scan-code has been altered to ');
      TextColor (yellow);
      Write (scan_title);
      TextColor (brown);
      Writeln ('.');
      Writeln ('Be sure to change the file HELPER.### to reflect this.');
      End;
   Writeln;
   Writeln
('Be sure to reboot the system in order to bring the new options into effect.');
   End;
choice := Esc;
End;

Procedure Init_Defaults;
Begin
For x := 1 to 6 do
   color[x] := Get_Byte (position_of_colors + x - 1);
row := Get_Byte (position_of_location);
column := Get_Byte (position_of_location + 1);
scan_code := Get_Byte (position_of_invoker);
scan_char := Get_Byte (position_of_invoker + 1);
End;

Procedure Header;
Begin
ClrScr;
WriteLn ('HELPER installation program by C.H.Thomann');
Doublet ('Modify ', 'C');
Doublet (')olors, ', 'M');
Doublet (')enu Position, ', 'I');
Doublet (')nvocation KeyStroke or ', 'U');
Doublet (')pdate and Quit', '');
Writeln;
TextColor (brown);
Writeln ('Press <Esc> to quit without update.');
End;

Begin
Assign (Com_File, 'Helper.Com');
{$I-} Reset (Com_File); {$I+}
If IOResult <> 0 Then
   Error ('Helper.Com could not be opened');
Read (Com_File, byt);
If byt <> $E9 Then
   Error ('Helper.Com is not a Turbo .COM file');
there_has_been_activity := False;
Init_Defaults;
Header;
Repeat
   Begin
   If Get_Stroke (choice) = extended then
      Begin
      If choice <> Esc then
         Beep;
      End
   Else
      Begin
      Case choice of
         'C', 'c' : Modify_Colors;
         'M', 'm' : Modify_Position;
         'I', 'i' : Modify_KeyStroke;
         'U', 'u' : Update_Com;
         Else       Beep;
         End;
      If ((choice in ['C', 'I', 'M', 'U', 'c', 'i', 'm', 'u']))
      And (choice <> Esc) then
         Header;
      End;
   End
Until choice = Esc;
Close (Com_File);
End.
